#pragma once

#include <cstdint>

#define		XTG_REALISTIC					1
#define		XTG_FUNC						1
#define		XTG_REALISTIC_WINAPI			2
#define		XTG_LOGIC						4
#define		XTG_DG_ON_XMASK					3
#define		XTG_VIRTUAL_ADDR				1
#define		XTG_OFFSET_ADDR					0

typedef unsigned long DWORD32;
typedef uint32_t UINT32;

#define ERROR_CODE						int

//xTG Engine Structure
typedef struct	xtg_trash_gen {
	__in    DWORD32                         fmode;
	__in    DWORD32                         rang_addr;
	__in    DWORD32                         faka_addr;
	__in    DWORD32                         faka_struct_addr;
	__in    DWORD32                         xfunc_struct_addr;
	__in    DWORD32                         xdata_struct_addr;
	__in    DWORD32                         alloc_addr;
	__in    DWORD32                         free_addr;
	__in    DWORD32                         tw_trash_addr;
	__in    UINT32                          trash_size;
	__in    DWORD32                         xmask1;
	__in    DWORD32                         xmask2;
	__in    DWORD32                         fregs;
	__out   UINT32                          number_of_bytes_written;
	__out   DWORD32                         trash_oep;
	__out   DWORD32                         fnw_addr;
}  XTG_TRASH_GEN;
typedef XTG_TRASH_GEN* PXTG_TRASH_GEN;


// FAKA Engine structure
struct faka_fakeapi_gen {
	// ... (existing members)
};

typedef faka_fakeapi_gen FAKA_FAKEAPI_GEN;
typedef FAKA_FAKEAPI_GEN* PFAKA_FAKEAPI_GEN;


//xTG Function Structure
struct xtg_func_struct {
	__in    DWORD32                         func_addr;
	__in    UINT32                          func_size;
	__in    UINT32                          call_num;
	__in    UINT32                          local_num;
	__in    UINT32                          param_num;
} ;
typedef xtg_func_struct XTG_FUNC_STRUCT;
typedef XTG_FUNC_STRUCT* PXTG_FUNC_STRUCT;

//xTG Data Structure
struct xtg_data_struct {
	__in    DWORD32                         xmask;
	__in    DWORD32                         rdata_addr;
	__in    UINT32                          rdata_size;
	__in    DWORD32                         rdata_pva;
	__in    DWORD32                         xdata_addr;
	__in    UINT32                          xdata_size;
	__in    UINT32                          number_of_bytes_written;
} ;
typedef xtg_data_struct XTG_DATA_STRUCT;
typedef XTG_DATA_STRUCT* PXTG_DATA_STRUCT;

struct xtg_main_struct {
	__in    PXTG_TRASH_GEN                  trash_gen_structure;
	__out   ERROR_CODE                      status;
} ;

typedef xtg_main_struct XTG_MAIN_STRUCT;
typedef XTG_MAIN_STRUCT* PXTG_MAIN_STRUCT;
